/*==================================================================================================

Copyright (c) 2007 UGS
Unpublished - All rights reserved

====================================================================================================
File description:

Filename: setDoubleArrayOperationDispatcher.hxx
Module  : extensionframework

This is the root interface class of the setDoubleArrayOperationDispatcher. It contains of all the generic methods
for setDoubleArrayOperationDispatcher that can be reused by the derived classes.

====================================================================================================
Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef setDoubleArrayOperationDispatcher_HXX
#define setDoubleArrayOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class setDoubleArrayOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::setDoubleArrayOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
public:
    setDoubleArrayOperationDispatcher();
    virtual ~setDoubleArrayOperationDispatcher();
    static OperationDispatcher *constructor();

    void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

    void setDoubleArrayPreConditions( Teamcenter::BusinessObject* obj, const std::vector<double>& doubleValues,  const std::vector<int>* isNullVals ) const;
    void setDoubleArrayPreActions( Teamcenter::BusinessObject* obj, const std::vector<double>& doubleValues,  const std::vector<int>* isNullVals  ) const;
    void setDoubleArrayBaseAction( Teamcenter::BusinessObject* obj, const std::vector<double>& doubleValues,  const std::vector<int>* isNullVals  ) const;
    void setDoubleArrayPostActions( Teamcenter::BusinessObject* obj, const std::vector<double>& doubleValues,  const std::vector<int>* isNullVals  ) const;

    // Project 011450 changes
    void setDoubleArrayPreConditions( METHOD_message_t* msgData, int num, const double* doubleValue, const logical* isNull ) const;
    void setDoubleArrayPreActions( METHOD_message_t* msgData, int num, const double* doubleValue, const logical* isNull ) const;
    void setDoubleArrayPostActions( METHOD_message_t* msgData, int num, const double* doubleValue, const logical* isNull ) const;
    void setDoubleArrayBaseAction( METHOD_message_t* msgData, int num, const double* doubleValue, const logical* isNull ) const;

    void setDoubleArray( Teamcenter::BusinessObject* obj, const std::vector<double>& doubleValues,  const std::vector<int>* isNullVals  ) const;

    void execute(Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
    void execute( tag_t objTag, va_list  args ) const;
    void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


    //Fix compiler warnings that were hiding virtual functions
    using Teamcenter::OperationDispatcher::executePreConditions;
    using Teamcenter::OperationDispatcher::executePreActions;
    using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //setDoubleArrayOperationDispatcher_HXX
